/*
 * DO NOT EDIT.  THIS FILE IS GENERATED FROM
 * /c/mozilla-build/mozilla/modules/libjar/nsIZipReader.idl
 */

package org.mozilla.interfaces;

public interface nsIZipReader extends nsISupports {

  String NS_IZIPREADER_IID =
    "{6ff6a966-9632-11d3-8cd9-0060b0fc14a3}";

  /**
     * Initializes a zip reader after construction.
     */
  void init(nsIFile zipFile);

  nsIFile getFile();

  /**
     * Opens a zip reader.
     */
  void open();

  /**
     * Closes a zip reader. Subsequent attempts to extract files or read from
     * its input stream will result in an error.
     */
  void close();

  /**
     * Tests the integrity of the archive by performing a CRC check 
     * on each item expanded into memory.  If an entry is specified
     * the integrity of only that item is tested.  If NULL is passed 
     * in the inetgrity of all items in the archive are tested.  
     */
  void test(String aEntryName);

  /**
     * Extracts a zip entry into a local file specified by outFile.
     */
  void extract(String zipEntry, nsIFile outFile);

  /**
     * Returns a nsIZipEntry describing a specified zip entry.
     */
  nsIZipEntry getEntry(String zipEntry);

  /**
     * Returns a simple enumerator whose elements are of type nsIZipEntry.
     */
  nsISimpleEnumerator findEntries(String aPattern);

  /**
     * Returns an input stream containing the contents of the specified zip entry.
     */
  nsIInputStream getInputStream(String zipEntry);

}